"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var redux_form_1 = require("redux-form");
var classnames_1 = __importDefault(require("classnames"));
var uuid = __importStar(require("uuid"));
var helpers_1 = require("@amalto/helpers");
var help_1 = __importDefault(require("@amalto/help"));
var Checkboxes = (function (_super) {
    __extends(Checkboxes, _super);
    function Checkboxes(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (event) {
            var input = _this.props.input;
            var selectedValues = input.value
                ? input.value.filter(function (item) { return !!item; })
                : [];
            if (event.target.checked) {
                input.onChange((0, helpers_1.addValToArrayNoDup)(selectedValues, event.target.value), undefined, undefined);
            }
            else {
                input.onChange((0, helpers_1.removeValFromArrayNoDup)(selectedValues, event.target.value), undefined, undefined);
            }
        };
        return _this;
    }
    Checkboxes.prototype.render = function () {
        var _this = this;
        var _a = this.props, label = _a.label, disabled = _a.disabled, help = _a.help, containerClass = _a.containerClass, inputClass = _a.inputClass, collapseErrorSpace = _a.collapseErrorSpace, options = _a.options, input = _a.input, meta = _a.meta;
        var inputId = uuid.v4();
        return (React.createElement("div", { className: (0, classnames_1.default)('form-group', containerClass, {
                invalid: meta.touched && !!meta.error,
                hidden: !options || options.length === 0,
            }) },
            label ? (React.createElement("label", null,
                label,
                help && React.createElement(help_1.default, { text: help }))) : null,
            React.createElement("div", { className: (0, classnames_1.default)('fieldset', {
                    invalid: meta.touched && !!meta.error,
                }) }, options
                .filter(function (opt) { return !!opt.value; })
                .map(function (opt, idx) {
                var _a;
                return (React.createElement("span", { className: (0, classnames_1.default)('form-checkbox-wrapper', inputClass, opt.classNames, {
                        hidden: opt.hidden,
                    }), key: idx },
                    React.createElement("input", { type: "checkbox", className: "form-checkbox", disabled: (_a = opt.disabled) !== null && _a !== void 0 ? _a : disabled, id: "".concat(inputId, "_").concat(input.name, "_").concat(idx), value: opt.value, onChange: function (e) { return _this.handleChange(e); }, checked: input.value.indexOf(opt.value) !== -1 }),
                    React.createElement("label", { className: "form-checkbox-label", htmlFor: "".concat(inputId, "_").concat(input.name, "_").concat(idx) }, opt.label || opt.value)));
            })),
            meta.touched && !!meta.error ? (React.createElement("p", { className: "validation-error-message" }, meta.error)) : collapseErrorSpace ? null : (React.createElement("p", { className: "validation-error-message" }, "\u00A0")),
            React.createElement("input", __assign({ type: "hidden" }, input))));
    };
    return Checkboxes;
}(React.PureComponent));
var CheckboxesInput = (function (_super) {
    __extends(CheckboxesInput, _super);
    function CheckboxesInput(props) {
        return _super.call(this, props) || this;
    }
    CheckboxesInput.prototype.render = function () {
        var _a = this.props, name = _a.name, format = _a.format, normalize = _a.normalize, parse = _a.parse, validate = _a.validate, warn = _a.warn;
        var baseFieldProps = {
            name: name,
            format: format,
            normalize: normalize,
            parse: parse,
            validate: validate,
            warn: warn,
        };
        return (React.createElement(redux_form_1.Field, __assign({}, baseFieldProps, this.props, { component: Checkboxes })));
    };
    return CheckboxesInput;
}(React.Component));
exports.default = CheckboxesInput;
//# sourceMappingURL=index.js.map